/*
Program:			Motor Library

File:				Motor.h
*/
#ifndef DRV8833_h
#define DRV8833_h

#include <stdint.h>
#include "esp_err.h"
#include "driver/mcpwm.h"

typedef struct {
	int intSpeed;
	int8_t pin1;
	int8_t pin2;
	char info; // bit0: isrunning, bit1: braked
	double defaultDuty;
    mcpwm_unit_t mcpwm_unit;
    mcpwm_io_signals_t mcpwm_a;
    mcpwm_io_signals_t mcpwm_b;
    mcpwm_timer_t mcpwm_timer;
} motor_h_t;


esp_err_t motor_install(int8_t a, int8_t b, mcpwm_unit_t pwm_u, mcpwm_io_signals_t pwm1, mcpwm_io_signals_t pwm2, mcpwm_timer_t t, motor_h_t **m);
esp_err_t motor_set_speed(motor_h_t *m, int intIn);
esp_err_t motor_stop(motor_h_t *m);
esp_err_t motor_start(motor_h_t *m);

#endif	/* DRV8833_h */